searchable.searchsequence

## Class OrderedSearchSequence

- java.lang.Object
- - searchable.searchsequence.SearchSequence
  - - searchable.searchsequence.SearchSequenceWithOrderedSelect
    - - searchable.searchsequence.OrderedSearchSequence

- All Implemented Interfaces:
    Searchable, SearchableWithMedian

      class OrderedSearchSequence
      extends SearchSequenceWithOrderedSelect
      implements Searchable

  Implementace uspořádané vyhledávací posloupnosti. Ve srovnání s SearchSequence zrychlí neúspěšná hledání prvků v posloupnosti.

  Popis: Hledání lze ukončit při nalezení prvního většího prvku. Metody insert a update musí zatřiďovat, aby nenarušily seřazení posloupnosti.

  Užití: instance této třídy lze používat v aplikacích.

- - ### Field Summary

    - ### Fields inherited from class searchable.searchsequence.SearchSequence

      `sequence`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `OrderedSearchSequence(Sequence aSequence)` Vyrobí instanci vyhledávací posloupnosti OrderedSearchSequence.
    `OrderedSearchSequence(SequenceFactory aSequenceFactory, int aSize)` Vyrobí instanci vyhledávací posloupnosti OrderedSearchSequence.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `insert(SearchableElement elem)` Zatřídí prvek do posloupnosti.
    `SearchableElement` | `selectMedian()` Najde medián.

    - ### Methods inherited from class searchable.searchsequence.SearchSequenceWithOrderedSelect

      `orderedSelect, select, update`

    - ### Methods inherited from class searchable.searchsequence.SearchSequence

      `getCount, getOperationCounter, getReadable, getSortCounter, isEmpty, isFull, remove, setSequence`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface searchable.searchableinterface.Searchable

      `getCount, getOperationCounter, getReadable, getSortCounter, isEmpty, isFull, remove, select, update`

- - ### Constructor Detail

    - #### OrderedSearchSequence

          public OrderedSearchSequence(SequenceFactory aSequenceFactory,
                                       int aSize)

      Vyrobí instanci vyhledávací posloupnosti OrderedSearchSequence.

      Popis: inicializuje atributy instance.

      Užití: zejména ve factory.

      Parameters:
        `aSequenceFactory` - továrna na posloupnosti
        `aSize` - požadovaná kapacita posloupnosti

    - #### OrderedSearchSequence

          public OrderedSearchSequence(Sequence aSequence)

      Vyrobí instanci vyhledávací posloupnosti OrderedSearchSequence.

      Popis: inicializuje atributy instance.

      Užití: volejte z konstruktorů odvozených tříd (dědiců).

      Parameters:
        `aSequence` - posloupnost, která se má prohledávat

  - ### Method Detail

    - #### insert

          public void insert(SearchableElement elem)

      Zatřídí prvek do posloupnosti.

      Popis: zatřídí nový prvek na správné místo v posloupnosti seřazené vzestupně.

      Vyžaduje: not isFull

      Specified by:
        `insert` in interface `Searchable`
      Overrides:
        `insert` in class `SearchSequence`
      Parameters:
        `elem` - prvek, který se má vložit

    - #### selectMedian

          public SearchableElement selectMedian()

      Description copied from interface: `SearchableWithMedian`
      Najde medián. Medián je prostřední prvek z posloupnosti nebo jiné uspořádané struktury. V případě sudého počtu prvků není výsledek jednoznačný - je lhostejné, který se najde.
      Specified by:
        `selectMedian` in interface `SearchableWithMedian`
      Specified by:
        `selectMedian` in class `SearchSequenceWithOrderedSelect`
      Returns:
        medián